function [ OutSeq ] = FindSeq

% This function determines the sorting of the codon encoding

% Please set variable "GenFolderName" to the name of the directories where files from calculations are
% please set variable/string "your_username" to be used in the directories


StartDir=pwd;

your_username = 'armando';

%% for Welch set

% cd ('..\Data')
% load('Data_Codon_WithNorm_MFE.mat')
% 
% SelPat = Data.Used & ~isnan(Data.Des) ;
% 
% NewData.InTemp = Data.In( SelPat ,:);
% NewData.Des = Data.DesNorm( SelPat );  % DesNorm
% 
% cd('..\Features')
% NewData.CodonCount =  codoncountArray(  Data.Sequence( SelPat ,:)  );
% [ ~, NewData.Codon ] = nt2codons(  Data.Sequence( SelPat ,:)  );
% [ NewData.CodonBias , ~ ] = CodonBiasArray( Data.Sequence( SelPat ) );  
% 
% NewData.In = [NewData.InTemp(:,9) NewData.CodonBias(:,1:end-3) NewData.Codon NewData.CodonCount];
% 
% ArrayOuterVal = 1:11;
% ArrayOuterLoopRep = 1:3;
% nTestPat = 5;
% GenFolderName = ['\CalculationsTest\SVM\Welch\SVM_MFEBiasLabelCount_3rep_125Param']  ;     
% %ParamVal = 37;
% UseZscore = 0;

%%
% %% for Kudla set
 
cd ('..\Data')
load('kudla_dataset_WithEnergy.mat')

cd('..\Features')
[ NewData.CodonBias , ~ ] = CodonBiasArray( Data.Sequence );  
[ ~ , NewData.Codon ] = nt2codons( Data.Sequence );  % nt2codons2 has the codon numbers sorted by 
NewData.CodonCount =  codoncountArray(  Data.Sequence );

NewData.In = [Data.rnaEnergyMinus4to37 NewData.CodonBias NewData.Codon NewData.CodonCount];
NewData.Des = Data.Des;

ArrayOuterLoopRep = 1:3;
ArrayOuterVal = 1:7;
nTestPat = 22;
GenFolderName = ['\CalculationsTest\SVM\Kudla\SVM_MFEBiasLabelCount_3rep_125Param'] ;
%ParamVal = 1;
UseZscore = 0;
%%

cd(StartDir)

InputAll = [];
DesAll = [];


for iOverOuterLoopRep = ArrayOuterLoopRep

    InputAll = [];
    DesAll = [];
    Seq = [];
    
    for iOverOuterValFold = ArrayOuterVal
        cd(['C:\Users\' your_username '\Documents\' GenFolderName '\OuterLoopRep' num2str(iOverOuterLoopRep)...
                       '\OuterFold_' num2str(iOverOuterValFold) '\Rep_1']);                                    % for SVM 
        
        load('Data.mat')
        InputAll = [InputAll; Input(end-(nTestPat-1):end,:)];
        DesAll = [DesAll; Desired(end-(nTestPat-1):end,:)];
    end
    
    randMatrix = rand(1,size([NewData.In NewData.Des],2));    % please remember that the columns are in the same position what is shuffled is the rows
    randMatrix = repmat(randMatrix,size([NewData.In NewData.Des],1),1);
    
    if UseZscore
        SumNewDataIn = sum((zscore([NewData.In NewData.Des])) .* randMatrix,2) ;
    else
        SumNewDataIn = sum(       ([NewData.In NewData.Des])  .* randMatrix,2) ;
    end
    
    for iOverPat = 1: size(InputAll,1)
        [minVal,Seq(iOverPat)] = min( abs(SumNewDataIn - sum( [InputAll(iOverPat,:) DesAll(iOverPat,:)] .* randMatrix(1,:) ,2) ) );
        
        if sum( minVal == abs(SumNewDataIn - sum( [InputAll(iOverPat,:) DesAll(iOverPat,:)] .* randMatrix(1,:) ,2) ) )~=1
            error('ARM: there cannot be two patterns with the same minVal')
        end
        if minVal>1e-10
            cd(StartDir)
            error('ARM: the difference is too large')
        end
    end
    
    if size( unique(Seq) , 2) < size( Seq , 2)
        cd(StartDir)
        error('ARM: Seq array is too small')
    end

    OutSeq(iOverOuterLoopRep).Seq = Seq;
    
end % for iOverOuterLoopRep = ArrayOuterLoopRep

cd(StartDir)

end

