function [ SVMModel ] = GetFinalSVM (resMSEVal)

% This function gets all the SVM that compose an ensemble average

% resMSEVal is the output of "ReadNFoldCrossValResultsSVM.m"

% please set variable "GenFolderName" to the directory where SVM are placed
% please set variable/string "your_username" to be used in the directories

StartDir = pwd;

your_username = '';

%% Welch

% nRep = 1;
% nOuterFold = 1; 
% nOuterLoopRep = 3;  %
% GenFolderName = '';  
 
%% Kudla
 
nRep = 1;
nOuterFold = 1;
nOuterLoopRep = 3;  
GenFolderName = '';  

%%

OuterLoopRep =[];

iOverOuterFold = 1; % since this is to determine the final SVM there is no test set likewise nOuterFold is also 1

for iOverOuterLoopRep = 1:nOuterLoopRep
    TempResVal = resMSEVal(iOverOuterLoopRep,iOverOuterFold,:);
    TempVal = find( TempResVal == nanmin( TempResVal ) );
    BestParam(iOverOuterLoopRep,iOverOuterFold) = TempVal(1);
end


for iOverOuterLoopRep = 1:nOuterLoopRep
    iOverOuterLoopRep
    
    folder = ['C:\Users\' your_username '\Documents\' GenFolderName '\OuterLoopRep' num2str(iOverOuterLoopRep) ...
        '\OuterFold_' num2str(nOuterFold) '\Rep_' num2str(nRep) ...
        '\Param_' num2str( BestParam(iOverOuterLoopRep,iOverOuterFold) )];
    
    cd( folder );
    
    LoadIn = load('SVMData.mat');
    
    SVMModel.OuterLoopRep(iOverOuterLoopRep).Model = LoadIn.SVMData(1).LastNet.SVMModel;
    
    clear LoadIn;
    
    
end



cd(StartDir)



end

