function [ AllBiasPerCodon AllCodonList ] = CodonBiasArray( Input )

% it uses "codonbias" function from Matlab to determine codon bias from various protein encodings

% Input is a row vector with a sequence of ATCG bases

% AllBiasPerCodon contains in rows various protein encodings and in columns the bias per codon 
% AllCodonList is the sequence of codons employed in AllBiasPerCodon

for iOverSeq = 1:size(Input,1); 
    Bias = codonbias(Input{ iOverSeq ,:});
    Names = fieldnames(Bias);
    CodonList = [];
    BiasPerCodon = []; 
    for iOverNames = 1: size(Names,1)
        CodonList = [ CodonList; eval(['Bias.' Names{iOverNames,:} '.Codon'])' ];
        BiasPerCodon = [ BiasPerCodon; eval(['Bias.' Names{iOverNames,:} '.Freq'])' ];
    end
    AllBiasPerCodon(iOverSeq,:) = BiasPerCodon';
    if iOverSeq == 1
        AllCodonList = CodonList; 
    else
        for iOverCodonList =1:size(CodonList,1)
            if ~prod( double (CodonList{iOverCodonList,:} == AllCodonList{iOverCodonList,:}))
                error('ARM: Codon lists are different')
            end
        end
    end    
end




end

