function [ out ] = codoncountArray( Input )

% This function counts the number of codons in each protein encoding

% Input is a row vector with a sequence of ATCG bases

% out contains in rows the various protein encodings and in columns the number of times each codon in a total of 64 appears in the protein encoding. 
%     The column sorting is that of Matlab function "codoncount"

for i=1:size(Input,1); 
    out(i,:) = cell2mat(struct2cell(codoncount(Input{i,:})))'; 
end;


end

