function [OuterLoopRep] = ReadResultsPLSTestSet2

% please set variable/string "your_username" to be used in the directories
% please change "GenFolderName" to the directory where calculations were stored

your_username = 'armando';

StartDir = pwd;

%% Welch
nTestPat = 5; 
nRep = 1;
nOuterFolds = 11; 
nOuterLoopRep = 3;
GenFolderName = ['C:\Users\' your_username '\Documents\CalculationsTest\PLS\Welch\PLS_MFEBiasLabelCount_3rep'];    

%% Kudla
% nTestPat = 22; 
% nRep = 1;
% nOuterFolds = 7; 
% nOuterLoopRep = 3;
% GenFolderName = ['C:\Users\' your_username '\Documents\CalculationsTest\PLS\Kudla\PLS_MFEBiasLabelCount_3rep'];  
 
%%

for iOverOuterLoopRep = 1:nOuterLoopRep

    for iOverOuterFold = 1:nOuterFolds
        
        OuterLoopRep(iOverOuterLoopRep).OuterFold(iOverOuterFold).SumAllRepTest=zeros(nTestPat,1);
        
        for iOverRep = [1:nRep];
            
            folder = [ GenFolderName '\OuterLoopRep' num2str(iOverOuterLoopRep) ...
                       '\OuterFold_' num2str(iOverOuterFold) '\Rep_' num2str(iOverRep)];
            
            cd( folder );
            
            load('PLSData.mat');
            
            OuterLoopRep(iOverOuterLoopRep).OuterFold(iOverOuterFold).AllRes(iOverRep).LastNet = PLSData(1).LastNet;
            
            OuterLoopRep(iOverOuterLoopRep).OuterFold(iOverOuterFold).SumAllRepTest = ...
                                    OuterLoopRep(iOverOuterLoopRep).OuterFold(iOverOuterFold).SumAllRepTest +...
                                    OuterLoopRep(iOverOuterLoopRep).OuterFold(iOverOuterFold).AllRes(iOverRep).LastNet.TestY/nRep;  % (:,end)
            
        end
        
        load('Data.mat')
        OuterLoopRep(iOverOuterLoopRep).OuterFold(iOverOuterFold).DesiredTest = Desired(end-nTestPat+1:end);
        OuterLoopRep(iOverOuterLoopRep).OuterFold(iOverOuterFold).Corr2SquaredTestSum = ...
                                        corr2( OuterLoopRep(iOverOuterLoopRep).OuterFold(iOverOuterFold).DesiredTest,...
                                               OuterLoopRep(iOverOuterLoopRep).OuterFold(iOverOuterFold).SumAllRepTest  ).^2;
        OuterLoopRep(iOverOuterLoopRep).OuterFold(iOverOuterFold).MSETestSum = ...
                                        mean(( OuterLoopRep(iOverOuterLoopRep).OuterFold(iOverOuterFold).DesiredTest -...
                                               OuterLoopRep(iOverOuterLoopRep).OuterFold(iOverOuterFold).SumAllRepTest  ).^2);
        
    end % for iOverOuterFold = 1:nOuterFolds
    
    for iOverParam = 1
        
        OuterLoopRep(iOverOuterLoopRep).Param(iOverParam).AllResTestOuterFolds = [];
        OuterLoopRep(iOverOuterLoopRep).Param(iOverParam).AllDesiredTestOuterFolds = [];
        
        for iOverOuterFold = 1:nOuterFolds
            
            OuterLoopRep(iOverOuterLoopRep).Param(iOverParam).AllResTestOuterFolds =     ...
                                [OuterLoopRep(iOverOuterLoopRep).Param(iOverParam).AllResTestOuterFolds; ...
                                 OuterLoopRep(iOverOuterLoopRep).OuterFold(iOverOuterFold).SumAllRepTest];
            OuterLoopRep(iOverOuterLoopRep).Param(iOverParam).AllDesiredTestOuterFolds = ...
                                [OuterLoopRep(iOverOuterLoopRep).Param(iOverParam).AllDesiredTestOuterFolds; ...
                                 OuterLoopRep(iOverOuterLoopRep).OuterFold(iOverOuterFold).DesiredTest];
                             
        end % for iOverOuterFold = 1:nOuterFolds
        
        OuterLoopRep(iOverOuterLoopRep).Param(iOverParam).AllMSETest = ...
                                mean(( OuterLoopRep(iOverOuterLoopRep).Param(iOverParam).AllDesiredTestOuterFolds - ...
                                       OuterLoopRep(iOverOuterLoopRep).Param(iOverParam).AllResTestOuterFolds ).^2);
        OuterLoopRep(iOverOuterLoopRep).Param(iOverParam).AllCorr2SquaredTest = ...
                                corr2( OuterLoopRep(iOverOuterLoopRep).Param(iOverParam).AllDesiredTestOuterFolds , ...
                                       OuterLoopRep(iOverOuterLoopRep).Param(iOverParam).AllResTestOuterFolds ).^2;
    end % for iOverParam = 1
    
end % for iOverOuterLoopRep = 1:nOuterLoopRep

cd(StartDir)

end



