function ScriptToRunSVMWithNFoldCrossVal2

% please set variable/string "your_username" to be used in the directories. The directories were tested in windows 8.1 
% please change "GenFolderName" to the directory where calculations must be stored
% please set the SVM parameters in "SVMWithNFoldCrossVal3.m"

your_username = 'armando';

clc;
StartDir=pwd;

%% set Welch
% 
% nPatternTest = 5;   
% iOverOuterValFoldArray = 1:11 ;               % number of outer folds
% iOverRepArray = 1:1;                          % keep to one
% iOverParamArray = 1:125;                      % number of different parameter configurations employed, parameters are defined inside function "GetPar" in "SVMWithNFoldCrossVal3.m"
%  
% iOverOuterLoopRepArray = 1:3;                 % number of nested n-fold cross-validation repetitions
% 
% kFoldVal = 5;                                 % number of inner folds
% TrainValPerc = (55-nPatternTest)/55;
% GenFolderName = ['C:\Users\' your_username '\Documents\CalculationsTest\SVM\Welch\SVM_MFEBiasLabelCount_3rep_125Param'];
% info = 'Dados Codon optimisation. Welch. Output expression';
% UsePreviousSeq = 0; % keep to zero
% cd ('..\Data')
% load('Data_Codon_WithNorm_MFE.mat')
% 
% SelPat = Data.Used & ~isnan(Data.Des) ;
% 
% NewData.InTemp = Data.In( SelPat ,:);
% NewData.Des = Data.DesNorm( SelPat );  % DesNorm
% 
% 
% cd('..\Features')
% NewData.CodonCount =  codoncountArray(  Data.Sequence( SelPat ,:)  );
% [ ~, NewData.Codon ] = nt2codons(  Data.Sequence( SelPat ,:)  );
% [ NewData.CodonBias , ~ ] = CodonBiasArray( Data.Sequence( SelPat ) );  
% 
%  NewData.In = [NewData.InTemp(:,9) NewData.CodonBias(:,1:end-3) NewData.Codon NewData.CodonCount];
% NewData.In = [NewData.CodonBias(:,[1,3,4,13,14,17,21,33,35,37,39,43,45,46,53])]; % Bias used in Welch article

%% set Kudla parameters

nPatternTest = 22;  
iOverOuterValFoldArray = 1:7;       % number of outer folds
iOverRepArray = 1:1;                % keep to one
iOverParamArray = 1:125;            % number of different parameter configurations employed, parameters are defined inside function "GetPar" in "SVMWithNFoldCrossVal3.m"
iOverOuterLoopRepArray = 1:3;       % number of nested n-fold cross-validation repetitions

kFoldVal = 6;                       % number of inner folds
TrainValPerc = (154-nPatternTest)/154;
GenFolderName = ['C:\Users\' your_username '\Documents\CalculationsTest\SVM\Kudla\SVM_MFEBiasLabelCount_3rep_125Param'];
info = 'Dados Codon optimisation. Kudla. Output is normalized fluorescence';
UsePreviousSeq = 0; % keep to zero

cd ('..\Data')
load('kudla_dataset_WithEnergy.mat')

cd('..\Features')
[ NewData.CodonBias , ~ ] = CodonBiasArray( Data.Sequence );  
[ ~ , NewData.Codon ] = nt2codons( Data.Sequence );  
NewData.CodonCount =  codoncountArray(  Data.Sequence );

NewData.In = [Data.rnaEnergyMinus4to37 NewData.CodonBias NewData.Codon NewData.CodonCount];
% NewData.In = [Data.rnaEnergyMinus4to37 NewData.CodonBias];
NewData.Des = Data.Des;


%%

cd(StartDir)

if matlabpool('size') ~=0
    matlabpool close
end    
matlabpool(7)

rand('state',sum(100*clock));


for iOverOuterLoopRep = iOverOuterLoopRepArray
    
    if UsePreviousSeq
        %SeqZero = FindSeq; %% to get previously used sequence
        error('ARM: not yet implemented')
    else
        SeqZero = randperm(size(NewData.Des,1)); %% random choice
    end
    
    NewData.In = NewData.In (SeqZero,:);
    NewData.Des = NewData.Des (SeqZero,:);
    
    
    parfor iOverOuterValFold = iOverOuterValFoldArray   % parfor
        
        SeqStart = (1:size(NewData.Des,1))';
        TestPatIndexInSeq = (iOverOuterValFold-1) * nPatternTest+1 : iOverOuterValFold * nPatternTest;
        TestPatValueInSeq = SeqStart(TestPatIndexInSeq);
        SeqStart(TestPatIndexInSeq) = [];
        SeqStart = [SeqStart; TestPatValueInSeq];
        
        for iOverRep = iOverRepArray
            
            Seq = SeqStart;
            SeqStartTemp = SeqStart( 1:end-nPatternTest );
            Seq(1:end-nPatternTest) = SeqStartTemp ( randperm( size(NewData.Des,1) - nPatternTest ) );
            
            for iOverTestPatterns = 1 : nPatternTest
                if ~isempty(find(Seq(1:end-nPatternTest) == Seq(end-iOverTestPatterns+1) ))
                    error('ARM: There are repeat patterns with test set')
                end
            end
            
            if size(unique(Seq),1) ~= size(Seq,1)
                error('ARM: There are repeated patterns')
            end
            
            DataDir = [ GenFolderName '\OuterLoopRep' num2str(iOverOuterLoopRep) ...
                '\OuterFold_' num2str(iOverOuterValFold) '\Rep_' num2str(iOverRep)]
            
            DataInput = NewData.In(Seq,:);
            DataDes   = NewData.Des(Seq,:); 
            
            mkdir(DataDir)
            cd(DataDir)
            parforsave([DataDir '\Data.mat'],DataInput,DataDes)
            cd(StartDir)
            
            for iOverParam = iOverParamArray
                
                SVMWithNFoldCrossVal3( DataInput , DataDes , TrainValPerc, kFoldVal, ...
                    [DataDir '\Param_' num2str(iOverParam) ], [iOverParam], info);
                
            end  % for iOverParam = iOverParamArray
            
        end  % for iOverRep = iOverRepArray
        
    end % for iOverOuterValFold = iOverOuterValFoldArray
    
end

matlabpool close

end

function parforsave( Dir , Input , Desired )

save(Dir,'Input','Desired')
    
end




